package com.company;

import com.sun.javafx.scene.control.skin.VirtualFlow;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

public class Player {
    // List of player's cards
    private ArrayList<Card> playerCards = new ArrayList<>();
    // point of the player
    private int playerPoint;

    protected ArrayList<Card> possibleCards = new ArrayList<>();
    private int counter = 0;

    /**
     * returns the list of player's cards
     * @return the list of player's cards
     */
    public ArrayList<Card> getPlayerCards() {
        return playerCards;
    }

    /**
     *
     * @param playerNumber
     */
    public void printAllCards(int playerNumber){
        System.out.println("Player" + playerNumber + ":");
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
    }

    public int getCounter() {
        return counter;
    }

    public ArrayList<Card> getPossibleCards() {
        return possibleCards;
    }

    public int getPlayerPoint() {
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            playerPoint += cardIterator.next().getCardPoint();
        }
        return playerPoint;
    }

    public void checkAllCards(Card card){
        boolean isColored = false;
        if (possibleCards == null)
            possibleCards = new ArrayList<>();
        if (possibleCards.size() > 1){
            for (int i = 1; i < possibleCards.size(); i++){
                possibleCards.remove(i);
                i--;
            }
        }
        if (card instanceof Colored)
            isColored = true;
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            if (c instanceof Colored) {
                if (isColored)
                    if (((Colored) c).checkEquality((Colored) card))
                        possibleCards.add(c);
            }
            else
                possibleCards.add(c);
        }
        if (possibleCards.size() > 0) {
            if (possibleCards.size() != searchWildDraws())
                deleteWildDraws();
        }

    }

    public Card randomPunishmentCard(ArrayList<Card> cards){
        Random r = new Random();
        int next = r.nextInt(cards.size());
        return cards.get(next);
    }

    public void printAllPossibleCards(int playerNumber){
        System.out.println("Player" + playerNumber + ": (Possible cards)");
        Iterator<Card> cardIterator = possibleCards.iterator();
        if (counter != 0) {
            cardIterator.next();
        }
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
        counter++;
    }

    private int searchWildDraws(){
        int counterWildDraw = 0;
       Iterator<Card> cardIterator = possibleCards.iterator();
       while (cardIterator.hasNext()){
           Card c = cardIterator.next();
           if (c instanceof WildDraw)
               counterWildDraw++;
       }
       return counterWildDraw;
    }

    private void deleteWildDraws(){
        for (int i = 0; i < possibleCards.size(); i++){
            if (possibleCards.get(i) instanceof WildDraw){
                possibleCards.remove(i);
                i--;
            }
        }
    }

    public Card chooseCardToThrow(ArrayList<Card> cards, Card c){
        return null;
    }

    public String chooseColorIfBlack(Card card){
        String s = null;
        return s;
    }

    public String toString(int playerNumber) {
        return "Player" + playerNumber +
                " {playerPoint=" + playerPoint +
                " }";
    }
    public void checkColors(String color){
        if (possibleCards == null)
            possibleCards = new ArrayList<>();
        if (possibleCards.size() > 1){
            for (int i = 1; i < possibleCards.size(); i++){
                possibleCards.remove(i);
                i--;
            }
        }
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            if (c instanceof Colored)
               if(c.cardColor.equals(color))
                   possibleCards.add(c);
        }

    }

    public Card chooseColorToThrow(ArrayList<Card> cards, String Color){
        return null;
    }
}
